/*
 *  Draco Econometrics
 *  Copyright (C) 2006-2007 Approximatrix, LLC
 *  http://www.approximatrix.com
 *  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.approximatrix.draco.math.mesp.psuedologic;

import com.graphbuilder.math.func.Function;

/** Provides some simple 'if' functionality.  If a number is greater
 *  than zero, it will return the second number.  If a number is less
 *  than or equal to zero, it will return either the third number or
 *  a NaN depending on the available data.
 *  
 * @author armstrongj
 *
 */
public class IfFunction implements Function {

	public IfFunction() {}
	
	public double of(double[] arg0, int arg1) {
		double return_value = Double.NaN;
		
		if(arg1 > 0) {
			if(arg1 > 1 && arg0[0] > 0.0)
				return_value = arg0[1];
			else if(arg1 > 2 && arg0[0] <= 0.0)
				return_value = arg0[2];
		}
		return return_value;
	}

	public boolean acceptNumParam(int arg0) {
		if(arg0 == 2 || arg0 == 3)
			return true;
		else
			return false;
	}
	
	public String toString() {
		return "if(x,y,[z])";
	}

}
